// Copyright 2012 Thomas Loy.
//
// This file is part of EggMob.
//
// EggMob is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// EggMob is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with EggMob.  If not, see <http://www.gnu.org/licenses/>.

package edu.self.eggMob;

import java.util.Collection;
import java.util.logging.Logger;
import org.bukkit.Effect;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Animals;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Tameable;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PotionSplashEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.configuration.file.FileConfiguration;
// begin dirty
import org.bukkit.craftbukkit.entity.CraftThrownPotion;
// end dirty


public class EggMobPlugin extends JavaPlugin implements Listener {
        private Logger log = Logger.getLogger("Minecraft");
        private double threshold = 0.0d;
        private int potionid = 16392;
        
        public void onEnable() {
                getServer().getPluginManager().registerEvents(this, this);
                getConfig().options().copyDefaults(true);
                threshold = getConfig().getDouble("threshold");
                potionid = getConfig().getInt("potionid");
                for (SpawnEggType spawnEggType : SpawnEggType.values()) {
                        String creatureName = spawnEggType.getCreatureType().getName();
                        boolean enable = getConfig().getBoolean("mobs." + creatureName);
                        spawnEggType.setEnabled(enable);
                }
                saveConfig();
        }

        public void onDisable() {
        }

        @EventHandler
        public void onPotionSplash(PotionSplashEvent event) {
                // Bukkit currently cannot tell us the type of a potion.
                // Hence we have to use undocumented functions from CraftBukkit for the time being.
                // begin dirty
                int dmg = ((CraftThrownPotion)(event.getPotion())).getHandle().f();
                if (dmg != potionid) { // Weakness
                        return;
                }
                // end dirty
                Collection<LivingEntity> affect;
                affect = event.getAffectedEntities();
        affectedEntityLoop:
                for (LivingEntity livingEntity : affect) {
                        // never turn spawned animals into eggs
                        if (livingEntity instanceof Tameable) {
                                if (((Tameable)livingEntity).isTamed()) {
                                        continue affectedEntityLoop;
                                }
                        }
                        // don't pack baby animals either
                        if (livingEntity instanceof Animals) {
                                if (!((Animals)livingEntity).isAdult()) {
                                        continue affectedEntityLoop;
                                }
                        }
                        int id = 0;
                spawnEggTypeLoop:
                        for (SpawnEggType spawnEggType : SpawnEggType.values()) {
                                if (spawnEggType.isInstance(livingEntity)) {
                                        if (spawnEggType.isEnabled()) {
                                                id = spawnEggType.getId();
                                                break spawnEggTypeLoop;
                                        } else {
                                                continue affectedEntityLoop;
                                        }
                                }
                        }
                        if (id == 0) {
                                continue affectedEntityLoop;
                        }
                        double intensity = event.getIntensity(livingEntity);
                        if (intensity < threshold) {
                                continue affectedEntityLoop;
                        }
                        livingEntity.remove();
                        Location location = livingEntity.getLocation();
                        World world = location.getWorld();
                        ItemStack item = new ItemStack(383, 1, (short)id);
                        world.dropItem(location, item);
                        // make a nice smoke effect
                        world.playEffect(location, Effect.SMOKE, 0); // data seems to be ignored
                }
        }
}
