// Copyright 2012 Thomas Loy.
//
// This file is part of EggMob.
//
// EggMob is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// EggMob is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with EggMob.  If not, see <http://www.gnu.org/licenses/>.

package edu.self.eggMob;

import org.bukkit.entity.Blaze;
import org.bukkit.entity.CaveSpider;
import org.bukkit.entity.Chicken;
import org.bukkit.entity.Cow;
import org.bukkit.entity.Creeper;
import org.bukkit.entity.EnderDragon;
import org.bukkit.entity.Enderman;
import org.bukkit.entity.Ghast;
import org.bukkit.entity.Giant;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.MagmaCube;
import org.bukkit.entity.MushroomCow;
import org.bukkit.entity.Pig;
import org.bukkit.entity.PigZombie;
import org.bukkit.entity.Sheep;
import org.bukkit.entity.Silverfish;
import org.bukkit.entity.Skeleton;
import org.bukkit.entity.Slime;
import org.bukkit.entity.Snowman;
import org.bukkit.entity.Spider;
import org.bukkit.entity.Squid;
import org.bukkit.entity.Wolf;
import org.bukkit.entity.Zombie;
import org.bukkit.entity.CreatureType;

public enum SpawnEggType {
        PIG_ZOMBIE(57, CreatureType.PIG_ZOMBIE),
        CAVE_SPIDER(59, CreatureType.CAVE_SPIDER),
        MAGMA_CUBE(62, CreatureType.MAGMA_CUBE),
        CREEPER(50, CreatureType.CREEPER),
        SKELETON(51, CreatureType.SKELETON),
        SPIDER(52, CreatureType.SPIDER),
        GIANT(53, CreatureType.GIANT),
        ZOMBIE(54, CreatureType.ZOMBIE),
        SLIME(55, CreatureType.SLIME),
        GHAST(56, CreatureType.GHAST),
        ENDERMAN(58, CreatureType.ENDERMAN),
        SILVERFISH(60, CreatureType.SILVERFISH),
        BLAZE(61, CreatureType.BLAZE),
        ENDER_DRAGON(63, CreatureType.ENDER_DRAGON),
        PIG(90, CreatureType.PIG),
        SHEEP(91, CreatureType.SHEEP),
        COW(92, CreatureType.COW),
        CHICKEN(93, CreatureType.CHICKEN),
        SQUID(94, CreatureType.SQUID),
        WOLF(95, CreatureType.WOLF),
        MUSHROOM_COW(96, CreatureType.MUSHROOM_COW),
        SNOWMAN(97, CreatureType.SNOWMAN),
        VILLAGER(120, CreatureType.VILLAGER);

        private int id;
        private CreatureType creatureType;
        private boolean enabled = true;

        private SpawnEggType(int id, CreatureType creatureType) {
                this.id = id;
                this.creatureType = creatureType;
        }

        public int getId() {
                return id;
        }

        public boolean isInstance(LivingEntity livingEntity) {
                return creatureType.getEntityClass().isInstance(livingEntity);
        }

        public CreatureType getCreatureType() {
                return creatureType;
        }

        void setEnabled(boolean v) {
                enabled = v;
        }

        boolean isEnabled() {
                return enabled;
        }
}
